TestReading = function()
	local dbfTable2 = dbfDatabase:OpenTable("AST14DEM_V2_V3_04042006")

	for i = 0, dbfTable2.FieldsCount - 1 do
		local record = dbfTable2:FetchRecord(i)
	end
end

AddRecord = function(table, v1, v2)
	local record = DbRecord(table)
	local field1 = record:GetField(0)
	local field2 = record:GetField(1)

	if type(v1) == "string" then
		field1:SetString(v1)
	elseif type(v1) == "number" then
		field1:SetNumber(v1)
	else
		field1:SetString(tostring(v1))
	end

	if type(v2) == "string" then
		field2:SetString(v2)
	elseif type(v2) == "number" then
		field2:SetNumber(v2)
	else
		field2:SetString(tostring(v2))
	end

	table:AddRecord(record)
end

TestRecord = function(table, recnum, v1, v2)
	local record = table:FetchRecord(recnum)
	local field1 = record:GetField(0)
	local field2 = record:GetField(1)

	if type(v1) == "string" then
		if field1:GetString() ~= v1 then
			ErrorMsgBox("Invalid field 1 string: " .. field1:GetString() .. " when \'" .. v1 .. "\' is expected")
			return
		end
	elseif type(v1) == "number" then
		if field1:GetNumber() ~= v1 then
			ErrorMsgBox("Invalid field 1 number: " .. field1:GetNumber() .. " when " .. v1 .. " is expected")
			return
		end
	else
		if field1:GetString() ~= tostring(v1) then
			ErrorMsgBox("Invalid field 1 value: " .. field1:GetString() .. " when \'" .. v1 .. "\' is expected")
			return
		end
	end

	if type(v2) == "string" then
		if field2:GetString() ~= v2 then
			ErrorMsgBox("Invalid field 2 string: " .. field2:GetString() .. " when \'" .. v2 .. "\' is expected")
			return
		end
	elseif type(v2) == "number" then
		if field2:GetNumber() ~= v2 then
			ErrorMsgBox("Invalid field 2 number: " .. field2:GetNumber() .. " when " .. v2 .. " is expected")
			return
		end
	else
		if field2:GetString() ~= tostring(v2) then
			ErrorMsgBox("Invalid field 2 value: " .. field2:GetString() .. " when \'" .. v2 .. "\' is expected")
			return
		end
	end
end

-- Testing Db

local dbfEngine   = CreateDbfEngine()
local dbfDatabase = dbfEngine:OpenDatabase(MakeLocalPath(""))
local dbfTable    = dbfDatabase:CreateTable("a", "Name:C50;Height:N8.4")

if dbfTable.FieldsCount ~= 2 then
	ErrorMsgBox("Invalid fields count: " .. dbfTable.FieldsCount .. " when 2 is expected")
end

AddRecord(dbfTable, "Name 1", 1)
AddRecord(dbfTable, "Name 2", 2)

TestRecord(dbfTable, 0, "Name 1", 1)
TestRecord(dbfTable, 1, "Name 2", 2)

InfoMsgBox("All done !")
